package com.regexlab.ftp;

import java.io.*;
import java.text.*;
import java.util.*;

/** *
 * һЩԼĹߺ
 */

public class Tools{

    public static final long KB = 1024;
    public static final long MB = 1024 * KB;
    public static final long GB = 1024 * MB;

    // ݿУһ滻
    public static String R(String str)
    {
        return replace(str, "'", "''");
    }

    // ȡԿոַֽindex1
    public static String SubStr(String str, int index)
    {
        if(index<1)index=1; // index1

        int ls = str.length();
        int i=0, j=0, times=0;

        str += ' ';
        do
        {
            i=j;
            while(str.charAt(i)==' ' && i<ls)i++;
            j=i;
            while(str.charAt(j)!=' ' && j<ls)j++;

            times++;
        }while(times!=index && i<ls);

        return str.substring(i, j);
    }

    // ȡԿոַֽʼλãindex1ֵ0
    public static int SubStrPos(String str, int index)
    {
        if(index<1)index=1; // index1

        int ls = str.length();
        int i=0, j=0, times=0;

        str += ' ';
        do
        {
            i=j;
            while(str.charAt(i)==' ' && i<ls)i++;
            j=i;
            while(str.charAt(j)!=' ' && j<ls)j++;

            times++;
        }while(times!=index && i<ls);

        return i;
    }

    public static String left(String str, int l)
    {
        int lstr = str.length();
        if(lstr < l)
            return str;
        return str.substring(0, l);
    }

    // ȡҶַ
    public static String right(String s, int l)
    {
        int ls = s.length();
        if(ls<=l)
            return s;
        return s.substring(ls-l, ls);
    }

    // ַ滻
    public static String replace(String str, String oldstr, String newstr)
    {
        StringBuffer result = new StringBuffer();
        int lstr = str.length();
        int loldstr = oldstr.length();

        int p=0;
        int off0=0, off1;
        while(p<=lstr-loldstr)
        {
            off1=off0;
            do
            {
                if(str.charAt(p+off1)==oldstr.charAt(off1))
                    off1=(off1+1) % loldstr;
                else
                {
                    off0=off1++;
                    break;
                }
            }while(off1!=off0);

            if(off1==off0) // 滻
            {
                result.append(newstr);
                p += loldstr;
            }
            else  // һַ
                result.append(str.charAt(p++));
        }
        // ʣµַ
        while(p<lstr)
            result.append(str.charAt(p++));

        return result.toString();
    }

    // Ŀ¼ռС
    public static long DirSize(String dir)
    {
        return DirSize(dir, 0);
    }

    //  level ־ļϵͳѭֻв֧̫Ŀ¼
    private static long DirSize(String dir, int level)
    {
        if(level>30)    // ݶΪ30㣬ƹ
            return -1;

        File d = new File(dir);
        String nms[] = d.list();
        long dsize = d.length();

        for(int i=0;i<nms.length;i++)
        {
            File f  = new File(dir + "/" + nms[i]);

            if(f.isDirectory()){
                long ds = DirSize(dir+"/"+nms[i], level+1);
                if(ds == -1)
                    return -1;  // ̫ش
                dsize += f.length() + ds;
            }else{
                dsize += f.length();
            }
        }

        return dsize;
    }

    // Ŀ¼ռСmax߲̫-1
    public static long DirSizeMax(String dir, long max)
    {
        return DirSizeMax(dir, 0, max, 0);
    }

    //  level ־ļϵͳѭֻв֧̫Ŀ¼
    private static long DirSizeMax(String dir, long siz, long max, int level)
    {
        if(level>30)    // ݶΪ30㣬ƹ
            return -1;

        File d = new File(dir);
        String nms[] = d.list();
        long dsize = d.length();  // ۼӱĿ¼С
        long nsize = siz + dsize; // ǰС + Ŀ¼С

        for(int i=0;i<nms.length;i++)
        {
            File f  = new File(dir + "/" + nms[i]);

            if(f.isDirectory()){
                long ds = DirSizeMax(dir+"/"+nms[i], nsize, max, level+1);
                if(ds == -1)
                    return -1;    // ̫̫󣬷ش
                dsize += f.length() + ds;
            }else{
                dsize += f.length();
            }

            nsize = siz + dsize;  // ǰС + Ŀ¼С

            if(nsize > max)
                return -1;
        }

        return dsize;
    }

    // Ŀ¼ȥ/./к/..///\\\
    public static String fmtDir(String dir)
    {
        if(dir.length()==0)
            dir = "/";
        dir = replace(dir, "\\","/");

        String drive = "";
        if(dir.length() >= 2)
        {
            drive = dir.substring(0,2);
            if(dir.charAt(1)==':')       // drive.equals("//") ȡ
                dir = dir.substring(2);
            else
                drive = "";
        }

        if(dir.length()==0)
            dir = "/";
        dir = replace(dir, "//", "/");
        if(dir.charAt(dir.length()-1)!='/')
            dir += "/";
        dir = replace(dir, "/./", "/");

        int p;
        while((p=dir.indexOf("/../"))>=0)
        {
            if(p>0)
            {
                int pup;
                if((pup=dir.substring(0,p).lastIndexOf('/'))>=0)
                    dir = dir.substring(0,pup)+dir.substring(p+3);
                else
                    dir = dir.substring(p+3);
            }
            else
                dir = dir.substring(3);
        }

        return drive + dir;
    }

    public static String fmtPath(String currDir, String strPath)
    {
        String tmpPath = "/"+strPath;
        if(right(tmpPath, 3).equals("/..") || right(tmpPath, 2).equals("/."))
            strPath += "/";

        if(strPath.length()<=0)
            tmpPath = currDir;
        else if(strPath.charAt(0)=='/')
            tmpPath = strPath;
        else
            tmpPath = currDir+strPath;

        int pd = tmpPath.lastIndexOf('/');
        if(pd<0)
            return strPath;
        else
            return fmtDir(tmpPath.substring(0, pd+1))+tmpPath.substring(pd+1);
    }

    public static String fmtShortTime(java.util.Date date)
    {
        Calendar now = Calendar.getInstance();
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        SimpleDateFormat fmtter = new SimpleDateFormat("", Locale.US);

        if(now.get(Calendar.YEAR) != cal.get(Calendar.YEAR))
            fmtter.applyPattern("yyyy.MM");
        else if(now.get(Calendar.DAY_OF_YEAR) != cal.get(Calendar.DAY_OF_YEAR))
            fmtter.applyPattern("MM.dd");
        else
            fmtter.applyPattern("HH:mm");

        return fmtter.format(date);
    }

    /*    
     *  yyyy  
     *  q     
     *  m     
     *  y     һ
     *  d     
     *  w     һܵ
     *  ww    
     *  h     ʱ
     *  n     
     *  s     
     */
    public static long DateDiff(String interval, java.util.Date date1, java.util.Date date2)
    {
        long seconds = (date2.getTime()-date1.getTime())/1000;

        // ʱ ʵʳȼ㣬
        //    13:1213:25СʱΪ0
        //    13:4514:10СʱҲΪ0ΪȲһСʱ
        if(interval.equals("s"))
            return seconds;

        if(interval.equals("n"))
            return seconds/60;

        if(interval.equals("h"))
            return seconds / (60*60);

        Calendar cal1 = Calendar.getInstance();
        Calendar cal2 = Calendar.getInstance();
        cal1.setTime(date1);
        cal2.setTime(date2);

        // Ĳǰʵʳȣǰ̶ȼ㣬
        //   ĳ1231(һ)11գΪ1Ȼʵֻһ죬Ϊͬһ
        //                                 ͬΪ1Ϊͬһ
        //                                     Ϊ0Ϊͬһڵ
        if(interval.equals("yyyy"))
            return cal2.get(Calendar.YEAR)-cal1.get(Calendar.YEAR);

        if(interval.equals("m"))
            return (cal2.get(Calendar.YEAR)-cal1.get(Calendar.YEAR)) *12
                  +(cal2.get(Calendar.MONTH)-cal1.get(Calendar.MONTH));

        if(interval.equals("w"))
            return cal2.get(Calendar.DAY_OF_WEEK)-cal1.get(Calendar.DAY_OF_WEEK);

        if(interval.equals("y"))
            return cal2.get(Calendar.DAY_OF_YEAR)-cal1.get(Calendar.DAY_OF_YEAR);

        if(interval.equals("q"))
            return (cal2.get(Calendar.YEAR)-cal1.get(Calendar.YEAR)) *4
                  +(cal2.get(Calendar.MONTH)/3-cal1.get(Calendar.MONTH)/3);

        cal1.set(Calendar.HOUR_OF_DAY, 1);
        cal2.set(Calendar.HOUR_OF_DAY, 3);
        seconds = (cal2.getTime().getTime() - cal1.getTime().getTime())/1000;
        long days;
        if(seconds >= 0)
            days = seconds / (60*60*24);
        else
            days = seconds / (60*60*24) -1;

        if(interval.equals("d"))
            return days;

        if(interval.equals("ww")){
            long days_from_weekhead = cal1.get(Calendar.DAY_OF_WEEK) + days -1; // DAY_OF_WEEK = 1 ~ 7
            if(days_from_weekhead >= 0)
                return days_from_weekhead/7;
            else
                return days_from_weekhead/7 -1;
        }

        return Long.MIN_VALUE;
    }
}
